<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL$                                                                   
// +------------------------------------------------------------------------+  
// | Maintain - DNS/DHCP Managment Tool                                     |  
// +------------------------------------------------------------------------+  
// | Copyright (c) 2004 Open Source University                              |  
// +------------------------------------------------------------------------+  
// | This program is free software; you can redistribute it and/or          |  
// | modify it under the terms of the GNU General Public License            |  
// | as published by the Free Software Foundation; either version 2         |  
// | of the License, or (at your option) any later version.                 |  
// |                                                                        |  
// | This program is distributed in the hope that it will be useful,        |  
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |  
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |  
// | GNU General Public License for more details.                           |  
// |                                                                        |  
// | You should have received a copy of the GNU General Public License      |  
// | along with this program; if not, write to the Free Software            |  
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |  
// | Boston, MA  02111-1307, USA.                                           |  
// +------------------------------------------------------------------------+  
// | Author(s): Kevin Purdy <purdyk@net.oregonstate.edu>                    |  
// +------------------------------------------------------------------------+  


/**                                                                            
 *  SearchForm.php - contains the {@link SearchForm} class                     
 *                                                                             
 *  @author $Author$                                                           
 *  @package    htdocs                                                         
 *  @subpackage forms                                                          
 *  @filesource                                                                
 */

class SearchForm extends FormContent
{

//{{{vars
    var $object_data = array();

//}}}
//{{{ form_init_elements()

  /**
   * This method builds the form itself and its elements
   */
    function form_init_elements()
    {
        $search = new FEText(_("Search"));
        $this->add_element($search);

        $otype_a = array(_("Hostname") => 0, _("Hardware Address") => 1, _("IP Address") => 2);
        $otype_g = new FERadioGroup(_("Field"), $otype_a, true);
        $otype_g->set_br_flag(true);
        $this->add_element($otype_g);

        $stype_g = new FERadioGroup(_("Type"), $this->_get_types(), true);
        $stype_g->set_br_flag(true);
        $this->add_element($stype_g);

        $this->set_required_marker(" ");

        $this->set_action($_SERVER["SCRIPT_NAME"]);
    }
//}}}
//{{{ form_init_data(
    function form_init_data()
    {
        $type = $this->get_element("Type");
        $type->set_value(key($type->_data_list[0]));
    }
//}}}
//{{{ form()
    function form()
    {
        $div = html_div("form");
        $table = html_table("45%");
        
        $tr = html_tr("odd");
        $tr->add($this->element_label(_("Search")), $this->element_form(_("Search")));
        $table->add($tr);
        
        $table->add_row("&nbsp;");
        
        $tr = html_tr("even");
        $obj = $this->element_form(_("Field"));
        $label = $this->element_label(_("Field"));
        $tr->add(container("&nbsp;", $label), $obj);
        $table->add($tr);

        $table->add_row("&nbsp;");

        $tr = html_tr("odd");
        $obj = $this->element_form(_("Type"));
        $label = $this->element_label(_("Type"));
        $tr->add(container("&nbsp;", $label), $obj);
        $table->add($tr);
        
        $table->add_row("&nbsp;");

		$this->set_cancel_action($_SERVER["SCRIPT_NAME"]);
        
        $tr = html_tr("even");
        $tr->add("&nbsp;", $this->add_action(_("Search")), $this->add_cancel());
        $table->add($tr);
          

        /* hidden form elements */
        $div->add($this->form_hidden());

        /* add in the table*/
        $div->add($table);

        return $div;
    }

    function form_hidden()
    {
	  $action = new FEHidden(_("action"), "search");
	  $this->add_element($action);
	  
	  return $this->element_form(_('action'));
    }
//}}}
//{{{ form_action()
    /**
     * Handle the search action
     */
    function form_action()
    {
        $res = true;
        switch (strtolower($this->get_action()))
        {
          
        case _("search"):
    	    break;
			
		default:
            break;
        } 
        return $res;
    }
//}}}
//{{{ _get_types()
    function _get_types()
    {
        $result = array();
        $m = new maintain_search();
        $ary = $m->searchGetAcceptableTypes("host");
        foreach ($ary as $var=>$val)
            $result[$val] = $val;
        return $result;
    }
//}}}
}