<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/trunk/class/update.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |       
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: update.php 4876 2007-03-23 23:18:05Z purdyk $


/**
  * update.php - Contains the {@link Update} class
  *
  * @author $Author: purdyk $
  * @filesource
  *
  * @package    classes
  */

/**
  * This class handles upgrading Maintain from one version to the next.
  *
  * Versions are a 6-digit number:
  * 
  *     220000
  *     ^       Major Revision
  *
  *     220000
  *      ^^     Minor Revision
  *
  * The last three digits are the build number
  *
  * @package    classes
  */
class Update {

    var $version;

//{{{ constructor
    function Update()
    {
        $this->version = $this->get_version();
    }
//}}}
//{{{ get_version()
    function get_version() {


		/* Make sure that update_info exits */
        $sql = "SHOW TABLES LIKE 'update_info'";
        $db_results = mysql_query($sql, dbh());

		// If no table
		if (!mysql_num_rows($db_results)) {
			
			$version = '220000';		
			
		} // if table isn't found

		else {
			// If we've found the update_info table, let's get the version from it

			$sql = "SELECT * FROM update_info WHERE `key`='db_version'";
            $db_results = mysql_query($sql, dbh());
            $results = mysql_fetch_object($db_results);
			$version = $results->value;
		} 
		return $version;
	}
///}}}
//{{{ run_update()
    function run_update()
    {
        global $conf;

        $sqldir = $conf['paths']['prefix']."/install/sql/";
        
        switch ($this->version)
        {
        case "220000":
        case "240001":
            $script = $sqldir."migrate2_4-3.sql";
            $res = $this->_upgrade_sql('300000', $script, false);
            if ($res !== true) return "MySQL error: ".$res;
        /* New upgrade cases go here */
        case "300000":
        case "310000":
            $script = $sqldir."range_overfill.sql";
            $res = $this->_upgrade_sql('310001', $script, true);
            if($res !== true) return "MySQL error: ".$res;
        case "310001":
            $script = $sqldir."modules_depends.sql";
            $res = $this->_upgrade_sql('310002', $script, true);
            if($res !== true) return "MySQL error: ".$res;
        case "310002":
            $script = $sqldir."host_date_fields.sql";
            $res = $this->_upgrade_sql('310003', $script, true);
            if($res !== true) return "MySQL error: ".$res;
            break;
        case "310003":
            $script = $sqldir."hardware_type.sql";
            $res = $this->_upgrade_sql('310004', $script, true);
            if($res !== true) return "MySQL error: ".$res;
            break;
        default:
            return _("The product is either up to date or the version {$this->version} 
                is not a valid version number. Maintain expected version number "
                .MAINTAIN_DB_VERSION.".");
            //<br>If you need help tracking down this problem, go to ".MAINTAIN_WEBSITE." for community support.");
            break;
        }
        return true;
    }
//}}}

// {{{ _upgrade_sql()
/**
  * Upgrade the database structure using an upgrade SQL file.
  * Update the DB version number on success.
  *
  * @access private
  * @param new version number to be set on success (or null for no change)
  * @param sql file to be imported
  * @param use transactions?
  * @return true on success, error msg otherwise
  */
    function _upgrade_sql($version, $sqlfile, $use_transaction = true)
    {
        $query = fread(fopen($sqlfile, "r"), filesize($sqlfile));  

        $dbh = dbh();
        
        $success = true;
        $stmts = explode(";", $query);
        if ($use_transaction) mysql_query('BEGIN TRANSACTION;');
        foreach ($stmts as $sql) {
            $sql = trim($sql);
            
            if (!$sql) continue;
            if ($sql[0] != '-' && $sql[0] != '#') {
                $res = mysql_query($sql, $dbh);
                if ($res === false) {
                    $err = mysql_error($dbh);
                    $success = false;
                    break;
                }
            }
        }
        if ($success) {
            if ($use_transaction) mysql_query('COMMIT;');
        } else {
            if ($use_transaction) mysql_query('ROLLBACK;');
            return $err;
        }

        // we were successful, so update database version number
        if (!is_null($version))
            mysql_query("UPDATE update_info SET `value` = '$version' WHERE `key` = 'db_version';");
        return true;
    }
// }}}
} // end update class

?>
