<?php

/**
  * Global Maintain Constants
  *
  * @package    includes
  */

// the current version of maintain
define("VERSION", "3");

// web site of the Maintain project
define("MAINTAIN_WEBSITE", "http://maintainproject.osuosl.org");

// integer values for user access levels
define("NO_ACCESS", 0);
define("GUEST", 5);
define("ZONE_USER", 25);
define("ZONE_ADMIN", 50);
define("ADMIN", 100);

// string values for object_history action types
define("ACTION_DELETE", 'delete');
define("ACTION_MODIFY", 'update');
define("ACTION_CREATE", 'create');

// values for Action Menu Factory
define("AM_LIST",1);
define("AM_SHOW",2);
define("AM_EDIT",3);

// minimum password length
define("PASSWORD_MIN_LEN", 8);
// length of a SHA-1 hash
define("SHA1_LEN", 40);
// length of MySQL [OLD_]PASSWORD() hash
define("MYSQL_OLD_PASSWORD_LEN", 16);

// length of a MAC address (no ':'s)
define("HA_LENGTH", 12);

// number of seconds in a day
define("DAY", 86400);

// fun with paths
define("MAINTAIN_ROOT", dirname(__FILE__));
define("CLASSDIR", MAINTAIN_ROOT."/class");
define("DAODIR", MAINTAIN_ROOT."/class/dao");
define("DAOEXT", MAINTAIN_ROOT."/class/dao/extended");
define("HTCLASS", MAINTAIN_ROOT."/class/htdocs");
define("FORMDIR", MAINTAIN_ROOT."/class/htdocs/forms");
define("BACKEND", MAINTAIN_ROOT."/class/backend");
define("CONFIG", MAINTAIN_ROOT."/maintain.cfg");
define("LIBDIR", MAINTAIN_ROOT."/lib");
define("INCLUDEDIR", MAINTAIN_ROOT."/includes");
define("MODDIR", MAINTAIN_ROOT."/modules");
define("HTDOCS", MAINTAIN_ROOT."/htdocs");
define("SKINDIR", HTDOCS."/skins");
define("BIN", MAINTAIN_ROOT."/bin");
define("BUILD", MAINTAIN_ROOT."/build");
define("DOCS", MAINTAIN_ROOT."/documentation");
define("INSTALLDIR", MAINTAIN_ROOT."/install");
// the constant 'PHPHTMLLIB' is set in includes/lib.php -> setup()

// default authentication module
define("DEFAULT_AUTH", 'auth_maintain');

// module constants (for $_REQUEST variables)
define("MODNAME", 'module_name');
define("MODPAGEPATH", 'page_path');

/* 
This is the patch version number for the upgrader to determine if
an upgrade of the database is necessary.
*/
define("MAINTAIN_DB_VERSION", "310004");
?>
