<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Michael Clay <claym@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id:$

/**
  * maintain_displayobj.php - contains the {@link Maintain_DisplayObject} class
  *
  * @author $Author:$
  * @filesource
  * @package    modules
  * @subpackage maintain_displayobj
  */

require_once MODDIR.'/core_module.php';
require_once dirname(__FILE__)."/DisplayObject.php";

/**
  * This is the 'Maintain_DisplayObj' module for Maintain, 
  * providing a basic way to display DB_DataObjects
  *
  * @package    modules
  * @subpackage maintain_displayobj
  */
class Maintain_DisplayObj extends Core_Module {

/* Overridden Module Methods */
// {{{ _install()

    /**
     *  This method takes care of operations that need to be carried out when the
     *  module is installed.  maintain_widgets requires nothing special.
     *
     *  @return Boolean true
     */
    function _install()
    {
        return true;
    }

// }}}
// {{{ _uninstall()

    /**
     *  This method takes care of operations that need to be carried out when the
     *  module is uninstalled.  maintain_widgets requires nothing special.
     *
     *  @return true
     */
    function _uninstall()
    {

        return true;

    }

// }}}
// {{{ register_hooks() (register methods to Maintain module hooks)

/**
  * Connect this module to the module hooks it should reply to
  *
  * @access public
  * @return void
  */
    function register_hooks()
    {
        Module::add_filter('object_info','display_object',5); 
    }
// }}}

//{{{ display_object()

    function display_object($content, $obj)
    {
        $content->add(new DisplayObject($obj));

        return $content;
    }

//}}}

}

?>
